{$A+,B-,D+,E-,F-,I+,L+,N-,O-,R+,S+,V-}
{$M 65520,0,0}
program DirRoom;  { (C) V.S. Rabets, 1992 }
                       { edition 11-11-92 }
uses DOS,CRT,DirRUnit;

const CopyRight = '!DirRoom, ver. 1.00.  (C) V.S. Rabets, 1992';

const CR = #13#10;                {  ப }
const DRfile: string = '';        { :\\ 䠩 !DirRoom }
      DRsize: longint = 0;        {   ࠧ }
      InfoMode: boolean = true;   { . ० -  ᮧ !DirRoom }
      Verbose: boolean = false;   { 뤠  ࠭ ࠧ஢  ⠫ }
      ClCount: longint = 0;       { ᫮ ஢   ⠫ }
var ClSizeB,                    {     }
    ClSizeEl,                   {  ,   ⠫ (1 .=32 )}
    FreeSpaceCl: word;          {  ࠭⢮  ᪥, ஢ }
    RootDir: string[3];         {  ୥ ⠫ (:\) }
    MaxY: byte absolute 0:$484; { ᫮ ப ࠭  1 }


procedure Help;
begin
  writeln ('ணࠬ - ᮪  SpeeDisk (Norton Utilities 6.0, 5.0, 4.5).'+
       CR+ '  䠩 ⠪ ࠧ, ⮡ ꥬ ᪮ ࠭⢠,'+
       CR+ '  ⨬ 䠩  ᥬ ﬨ ⠫ (஬ ୥),');
  writeln (' ࠢ .'+LF+
       CR+ '맮 ணࠬ:'+
       CR+ ' !DirRoom  drive[\path[\filename]] [size] [/V] [/P]'+LF+
       CR+ ' drive[\path[\filename]] - 㪠뢠 ࠡ뢠  , ,');
  writeln ('                             ⮯ ᮧ 䠩.'+
       CR+ '      , ⢥, ᥣ ᮧ  ࠡ뢠 ᪥.'+
       CR+ '       ਠ:');
  writeln ('         \\䠩 - 㪠뢠   䠩,   ⮯.'+
       CR+ '         \          - 䠩 !DIRROOM ᮧ  㪠 ४ਨ.'+
       CR+ '                        - 䠩 !DIRROOM ᮧ  ⥪饬 ⠫');
  writeln ('                              㪠 ᪠.'+
       CR+ ' size - ꥬ ᪮ ࠭⢠ ( ), ஥   䠩'+
         + '        !DirRoom    (஬ ୥) ⠫ (楫 ᫮).');
  writeln ('        ᫨ size<=0   㪠,  䠩 !DirRoom  ᮧ.'+
       CR+ ' /V (verbose) -   뤠 ࠧ  ⠫.'+
       CR+ ' /P (pause) - 㧠 ᫥ ᮮ饭  訡.');
  halt (1);
end;

procedure GetCommandLineParameters;
var Par: string;
    b: byte;
begin
  if ParamCount=0 then Help;
  for b:=ParamCount downto 1 do
  begin
    Par:=StrUpCase(ParamStr(b));
    if (Par='?') or (Par='/?') or (Par='/H') then Help else
    if (Par[2]=':') and (Par[1] in ['A'..'Z']) and (Par[0]>=#2)
       then DrFile:=Par else
    if Str2Long (Par, DRsize) then InfoMode:=DRsize<=0 else
    if Par='/V' then Verbose:=true else
    if Par='/P' then Pause := true else
    Error (' ᯮ ࠬ '+Par, 2);
  end;
  if DRfile='' then Error (' 㪠  㪠 ୮  [\[\]]', 2);
end;

procedure GetDiskParameters;
var R: registers;
begin
  with R do
  begin AH:=$36;
        DL:= byte(DRfile[1]) - byte(pred('A'));
        MsDos (R);
        if AX=$FFFF then
           Error (' 㤠  ࠬ ᪠ '+copy(DRfile,1,2), 3);
        ClSizeB:=AX*CX;
        ClSizeEl:=ClSizeB div 32;
        FreeSpaceCl:=BX;
  end;
end;

procedure DetermineDRfile;
var AltDRfile: string;
begin
  DRfile:=FExpand(DRfile);
  RootDir:=DRfile;
  if InfoMode then exit;
  AltDRfile:=DRfile;
  if not TextOpen (DRfile) then
  begin DRfile:=AddBackSlash(DRfile)+'!DirRoom';
    if not TextOpen (DRfile) then
       Error (' 㤠   '+AltDRfile+',  '+DRfile, 4);
  end;
end;

procedure WriteTableHeader;
begin
  writeln (LF+'  ᫮                     ४਩');
  writeln (   '⮢   -');
  window (1,WhereY, 80,MaxY);
end;

procedure CountDirSpace (Dir: string);
const HeadLength = 25;
var SRec: SearchRec;
    SizeEl, SizeCL: longint;   {       }
begin
  SizeEl:=0;
  Dir:=AddBackSlash(Dir);
  FindFirst (Dir+'*.*', AnyFile, SRec);
  while DosError=0 do
  with SRec do
  begin
    inc(SizeEl);
    if (Attr and 16 <>0) and (Name[1]<>'.') then  CountDirSpace (Dir+Name);
    FindNext(SRec);
  end;

  SizeCl:=SizeEl div ClSizeEl + byte( SizeEl mod ClSizeEl<>0 );
  if Dir<>RootDir then  begin
   inc (ClCount, SizeCl);
   if Verbose then  begin
    if length(Dir)<79-HeadLength then write('':HeadLength, Dir)
                                 else write(Dir:79, #13, '':HeadLength,'...');
    writeln (#13, SizeEl:8, SizeEl*32:8, SizeCl:6, '   ');
   end
  end
end;

procedure CreateDirRoomFile;
var DRfileSize,  {  䠩 !DirRoom   }
    l: longint;
begin
  if ClCount>DRsize then
     Error (' ⠫   , 祬 size.', 6);
  DRfileSize:=DRsize-ClCount;
  if DRfileSize>FreeSpaceCl then
     Error ('   ᮧ 䠩 !DIRROOM.', 5);
  if DRfileSize>0 then
     for l:=1 to DRfileSize*ClSizeEl do
     write (tf, '0123456789ABCDEF0123456789abcde ');
  {$I-} close(tf); {$I+}
  if IOResult>0 then Error ('   䠩 '+DRfile, 3);
  writeln (' 䠩 ', DRfile, ' ࠧ஬ ',
            DRfileSize*ClSizeB, '  (', DRfileSize, ' ஢).');
end;

begin
  ClrScr; TA:=$F; writeln (LF+CopyRight); TA:=7;
  GetCommandLineParameters;
  GetDiskParameters;
  DetermineDRfile;
  if Verbose then WriteTableHeader;
  CountDirSpace (RootDir);
  writeln (LF, '  ⠫ (஬ ୥)  ',
                ClCount, ' ஢ (',ClCount*ClSizeB div 1024, ' KB).');
  if not InfoMode then CreateDirRoomFile;
end.
